VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CBusinessTier"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'Declarations
Private mobjDataDBTier As CDataDBTier
Private mstrFirstName As String
Private mstrLastName As String
Private mstrAddress As String
Private mstrState As String
Private mstrCountry As String
Private mstrPostalCode As String
Private mstrPhone As String
Private mlngAddressID As Long

Public Function FillList() As Variant
'Declarations

Dim vntList As Variant

' this will connect to the dataDBTier and perform the sql statemen to get the items
'that will be filled in the list

        vntList = mobjDataDBTier.FillList

'On the return from the tiers we will take the information the database which has
'been packaged up and pass itover to the form

'Note: when crossing tiers you must package everything up or you wont be able to
'pass it throught the network.

        FillList = vntList
        
End Function
Public Sub GetAddressDetails(ByVal lngAddressID As Long)
Dim vntAddressDetials As Variant

' first of all we need to execture the SQL statement to find out wht is is that
'we intend to bring back from the database
vntAddressDetials = mobjDataDBTier.GetAddressDetails(lngAddressID)

' Now we use an array to bring the data back across the tiers

    lngAddressID = vntAddressDetials(0, 0)
    mstrFirstName = vntAddressDetials(1, 0) & ""
    mstrLastName = vntAddressDetials(2, 0) & ""
    mstrAddress = vntAddressDetials(3, 0) & ""
    mstrPostalCode = vntAddressDetials(4, 0) & ""
    mstrState = vntAddressDetials(5, 0) & ""
    mstrCountry = vntAddressDetials(6, 0) & ""
    mstrPhone = vntAddressDetials(7, 0) & ""
    
End Sub
Public Sub SaveAddress()
'bundle up the properties into an array and send the array to cCodeDB

    Dim vntAddressInfo(7, 0) As Variant
    vntAddressInfo(0, 0) = mlngAddressID
    vntAddressInfo(1, 0) = mstrFirstName
    vntAddressInfo(2, 0) = mstrLastName
    vntAddressInfo(3, 0) = mstrAddress
    vntAddressInfo(4, 0) = mstrPostalCode
    vntAddressInfo(5, 0) = mstrState
    vntAddressInfo(6, 0) = mstrCountry
    vntAddressInfo(7, 0) = mstrPhone
    mobjDataDBTier.SaveAddress (vntAddressInfo)

End Sub
Public Sub DeleteAddress(ByVal mlngAddressID As Long)

    mobjDataDBTier.DeleteAddress (mlngAddressID)
    
End Sub

'//////////////////////////////////////////////////////////////////////////////////////
'NOTE: Lets and Get: if you havent used lets and gets before then an easy way to explain
'them is to think of them as gate keepers to the database. Lets allow things in and Gets bring
'things out
'//////////////////////////////////////////////////////////////////////////////////////

Public Property Let FirstName(ByVal NewFirstName As String)

    mstrFirstName = NewFirstName
    
End Property
Public Property Get FirstName() As String

    FirstName = mstrFirstName   'Get the Title
    
End Property
Public Property Let LastName(ByVal NewLastName As String)

    mstrLastName = NewLastName
    
End Property
Public Property Get LastName() As String

    LastName = mstrLastName
    
End Property
Public Property Let Address(ByVal NewAddress As String)

     mstrAddress = NewAddress
     
End Property
Public Property Get Addresss() As String

     Addresss = mstrAddress    'Get the Author
     
End Property
Public Property Let PostalCode(ByVal NewPostalCode As String)

    mstrPostalCode = NewPostalCode
    
End Property
Public Property Get PostalCode() As String

    PostalCode = mstrPostalCode
    
End Property
Public Property Let State(ByVal NewState As String)

    mstrState = NewState
    
End Property
Public Property Get State() As String

    State = mstrState
    
End Property
Public Property Let Country(ByVal NewCountry As String)

    mstrCountry = NewCountry
    
End Property
Public Property Get Country() As String

    Country = mstrCountry
    
End Property
Public Property Let Phone(ByVal NewPhone As String)

     mstrPhone = NewPhone
     
End Property
Public Property Get Phone() As String

     Phone = mstrPhone      'Get the Date
     
End Property
Public Property Let AddressID(ByVal NewAddressID As Long)

    mlngAddressID = NewAddressID
    
End Property
Public Property Get AddressID() As Long

     AddressID = mlngAddressID
     
End Property

Private Sub Class_Initialize()

'Initialize a connection to the next tier
     Set mobjDataDBTier = New CDataDBTier
     
End Sub
Private Sub Class_Terminate()

     Set mobjDataDBTier = Nothing
     
End Sub
